//+------------------------------------------------------------------+
//|                                                   e-MACD_MTF.mq4 |
//|                                                 Copyright  2013 |
//|                                                                  |
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
extern string com               = " ";
extern double lots                 = 0.01;
extern int    stoploss             = 20;
extern int    takeprofit           = 30;
extern int    slippage             = 1;
extern int    magic                = 654321;
extern int    SleepOnBarAfterTrade = 1;
extern string comment              = "My_EA";
extern string com1              = " MACD  m1";
extern int    FastEMA1m            = 12;
extern int    SlowEMA1m            = 26;
extern int    SignalSMA1m          = 9;
extern string com2              = " MACD  m5";
extern int    FastEMA5m            = 12;
extern int    SlowEMA5m            = 26;
extern int    SignalSMA5m          = 9;
extern string com3              = " MACD  m15";
extern int    FastEMA15m           = 12;
extern int    SlowEMA15m           = 26;
extern int    SignalSMA15m         = 9;
extern string com4              = " MACD  m30";
extern int    FastEMA30m           = 12;
extern int    SlowEMA30m           = 26;
extern int    SignalSMA30m         = 9;
extern string com5              = " MACD  1";
extern int    FastEMAh1            = 12;
extern int    SlowEMAh1            = 26;
extern int    SignalSMAh1          = 9;
extern string com6              = " MACD  h4";
extern int    FastEMAh4            = 12;
extern int    SlowEMAh4            = 26;
extern int    SignalSMAh4          = 9;
//+------------------------------------------------------------------+
double        SL, TP;
int           ticket, gia_FastEMA[6], gia_SlowEMA[6], gia_SignalSMA[6],
              gia_Periods[] = {PERIOD_M1,PERIOD_M5,PERIOD_M15,PERIOD_M30,PERIOD_H1, PERIOD_H4};
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
{
    if (Digits % 2 == 1) //  5  4 
    {
        takeprofit *= 10;
        stoploss *= 10;
        slippage *= 10;
    }
	gia_FastEMA[0] = FastEMA1m;
	gia_SlowEMA[0] = SlowEMA1m;
	gia_SignalSMA[0] = SignalSMA1m;
	gia_FastEMA[1] = FastEMA5m;
	gia_SlowEMA[1] = SlowEMA5m;
	gia_SignalSMA[1] = SignalSMA5m;
	gia_FastEMA[2] = FastEMA15m;
	gia_SlowEMA[2] = SlowEMA15m;
	gia_SignalSMA[2] = SignalSMA15m;
	gia_FastEMA[3] = FastEMA30m;
	gia_SlowEMA[3] = SlowEMA30m;
	gia_SignalSMA[3] = SignalSMA30m;
	gia_FastEMA[4] = FastEMAh1;
	gia_SlowEMA[4] = SlowEMAh1;
	gia_SignalSMA[4] = SignalSMAh1;
	gia_FastEMA[5] = FastEMAh4;
	gia_SlowEMA[5] = SlowEMAh4;
	gia_SignalSMA[5] = SignalSMAh4;
    return (0);
}
//+------------------------------------------------------------------+
int deinit()
{
    return (0);
}
//+------------------------------------------------------------------+
void start()
{
    int kolpos = 0; //  
    for (int pos = 0; pos < OrdersTotal(); pos++)
    {
        if (!OrderSelect (pos, SELECT_BY_POS)) continue;
        if (OrderSymbol () != Symbol ()) continue;
		if (OrderMagicNumber() != magic) continue;
        kolpos++;
    }
	//----     - 
    if (kolpos > 0) return;
	int li_Bars = BarsAfterCloseLastPos (magic);
	//----     li_Bars   TF
	if (li_Bars > 0) if (li_Bars < SleepOnBarAfterTrade) return;
	double lda_MACD[2];
	int    li_IND, lia_Signal[] = {0,0};
    for (int li_PRD = 0; li_PRD < 6; li_PRD++)
	{
	    //----        TF
		for (li_IND = 0; li_IND < 2; li_IND++)
		{lda_MACD[li_IND] = iMACD (Symbol(), gia_Periods[li_PRD], gia_FastEMA[li_PRD], gia_SlowEMA[li_PRD], gia_SignalSMA[li_PRD], PRICE_CLOSE, li_IND, 0);}
		//----        
		if (NormalizeDouble (lda_MACD[0] - lda_MACD[1], Digits) > 0.) lia_Signal[0]++;
		else if (NormalizeDouble (lda_MACD[0] - lda_MACD[1], Digits) < 0.) lia_Signal[1]++;
		//----     TF    - 
		if (lia_Signal[0] < li_PRD + 1) if (lia_Signal[1] < li_PRD + 1) return;
	}
    //---- 
	if (lia_Signal[0] == 6)
    {
        ticket = OrderSend (Symbol(), OP_BUY, lots, Ask, slippage, 0, 0, comment, magic, 0, Green);
        if (ticket > 0)
        {
            if (OrderSelect (ticket, SELECT_BY_TICKET))   //        
            {
	            SL = NormalizeDouble (Ask - stoploss * Point, Digits);
                TP = NormalizeDouble (Ask + takeprofit * Point, Digits);
                OrderModify (ticket, OrderOpenPrice(), SL, TP, 0);   //         
				return;
            }
        }
    }
    //---- 
    if (lia_Signal[1] == 6)
    {
        ticket = OrderSend (Symbol(), OP_SELL, lots, Bid, slippage, 0, 0, comment, magic, 0, Red);
        if (ticket > 0)
        {
            if (OrderSelect (ticket, SELECT_BY_TICKET))   //        
            {
               SL = NormalizeDouble (Bid + stoploss * Point, Digits);
               TP = NormalizeDouble (Bid - takeprofit * Point, Digits);
               OrderModify (ticket, OrderOpenPrice(), SL, TP, 0);   //         
            }
        }
    }
}
//+------------------------------------------------------------------+
int BarsAfterCloseLastPos (int fi_MG, int fi_Type = -1)
{
    datetime ldt_Time = 0;
    int      li_Total = OrdersTotal();
//----
    for (int li_pos = 0; li_pos < li_Total; li_pos++)
    {
        if (!OrderSelect (li_pos, SELECT_BY_POS, MODE_HISTORY)) continue;
        if (OrderSymbol() != Symbol()) continue;
        if (fi_Type >= 0) if (OrderType() != fi_Type) continue;
        if (OrderMagicNumber() != fi_MG) continue;
        if (ldt_Time >= OrderCloseTime()) continue;
        ldt_Time = OrderCloseTime();
    }
    //----   -   
    if (ldt_Time == 0) return (-1);
//----
    return (iBarShift (NULL, 0, ldt_Time));
}
//+------------------------------------------------------------------+
